<?php

require_once('../../lib/_autoload.php');
require_once('../../modules/saml/lib/StorkMessage.php');
require_once('../../lib/SAML2/Constants.php');

$b = new SAML2_HTTPPost();
?>
<html>
<head>
  <title>Demo Service Provider:: (Secure Identity Across Borders Linked)</title>
  <link href="css/estilos.css" rel="stylesheet" type="text/css"/>
</head>

<body>
  
  <div id="contenedor">
  <div id="cabecera">
    <div class="logo"></div>
    <div class="tituloCabecera">Demo Service Provider: STORK</div>
  </div>
  <div id="borde">
    <div id="principal">
      <div id="margen">
  
<h1>DEMO-SP</h1>
<br />
<?php
$response = $b->receive();

$authSource = StorkConstants::SPID;
$as = SimpleSAML_Auth_Source::getById($authSource);
$metadata = $as->getMetadata();

try {
  $retVal = stork_saml_Message::checkSign($metadata, $response);
  if($retVal) {
    $assertions = $response->getAssertions();
    $attributes = $assertions[0]->getAttributes();
    $status = $response->getStatus();
    if('urn:oasis:names:tc:SAML:2.0:status:Success' !== $status['Code']) {
	    echo '<p>'.$status['Message'].'</p>';
    } else {
    	echo '<h2>Login Succeeded</h2>';
	    echo '<br /><h2>Requested Data:</h2><br />';
	    echo '<table>';
	    echo '  <TR class="filatit">';
    	echo '    <TD>Attribute</TD>';
    	echo '    <TD>Values</TD>';
    	echo '    <TD>Status</TD>';
  	  echo '  </TR>';

    	$keys = array_keys($attributes);
    	foreach($keys as $key) {
     		echo '<TR class="filaresult">';
     			$keyval = array_search($key, StorkConstants::$attrs);
     			$keyx = explode('.', $keyval);
     			echo '<TD>'.$keyx[0].'</TD>';
     			echo '<TD>'.$attributes[$key]['AttributeValues'].'</TD>';
     		  echo '<TD>'.$attributes[$key]['AttributeStatus'].'</TD>';
        echo '</TR>';
      }
      echo '</table>';
    } 
  }else {
    echo '<h2>An error occurred';
    echo '<p>The signature validation failed.</p>';
  }
} catch(Exception $e) {
   echo '<h2>An error occurred';
   echo '<p>An exception occured on the response processing.</p>';
}
?>
<p>
  Please, click
  <a href="/SP/">here</a> to go back to homepage.
</p>
    
      </div>
    </div>
  </div>
</div>
    
</body>
</html>
